package com.scalangular.f1.league.v2.usecases.common

import com.scalangular.f1.league.v2.entities.F1Driver
import com.scalangular.f1.league.v2.generated.transfer.entitys.DriverRaceResult
import com.scalangular.f1.league.v2.generated.transfer.entitys.F1RaceResultStatus
import com.scalangular.f1.league.v2.generated.transfer.entitys.RaceResult
import com.scalangular.f1.league.v2.usecases.common.AutogenerateDNSForRaceResultUseCase.AutogenerateDNSForRaceResultCommand
import java.util.*

class DefaultAutogenerateDNSForRaceResultUseCase : AutogenerateDNSForRaceResultUseCase {
    override fun addDNSToRaceResult(buildRaceResultCommand: AutogenerateDNSForRaceResultCommand): RaceResult {
        return if (everyDriverHasAResult(buildRaceResultCommand) || hasNoRaceResults(buildRaceResultCommand)) {
            buildRaceResultCommand.raceResult
        } else {
            generateAndAddDnsResults(buildRaceResultCommand, buildRaceResultCommand.raceResult.driverResults!!)
        }
    }

    private fun generateAndAddDnsResults(
        buildRaceResultCommand: AutogenerateDNSForRaceResultCommand,
        driverResults: List<DriverRaceResult>
    ): RaceResult {
        val driversThatTookPart = buildRaceResultCommand.raceResult.driverResults!!.map { it.driverId }
        val driversWithDNS =
            buildRaceResultCommand.drivers.filter { driver -> !driversThatTookPart.contains(driver.driverId) }

        return buildRaceResultCommand.raceResult.copy(
            driverResults = driverResults + driversWithDNS.map {
                buildDNSResultForDriver(
                    it, buildRaceResultCommand.raceResult.raceId
                )
            }
        )
    }

    private fun everyDriverHasAResult(buildRaceResultCommand: AutogenerateDNSForRaceResultCommand) =
        buildRaceResultCommand.drivers.size == (
            buildRaceResultCommand.raceResult.driverResults?.size
                ?: -1
            )

    private fun hasNoRaceResults(buildRaceResultCommand: AutogenerateDNSForRaceResultCommand) =
        buildRaceResultCommand.raceResult.driverResults?.isEmpty() == true || buildRaceResultCommand.raceResult.driverResults == null

    private fun buildDNSResultForDriver(driver: F1Driver, raceId: UUID?): DriverRaceResult {
        return DriverRaceResult(
            raceId,
            -1,
            -1,
            -1,
            -1f,
            -1.0,
            -1,
            -1f,
            -1,
            driver.driverId,
            driver.carNumber ?: -1,
            F1RaceResultStatus.notClassified
        )
    }
}
